package com.example.monnthic.monnthicmobile;

import org.web3j.protocol.Web3j;
import org.web3j.protocol.Web3jFactory;
import org.web3j.protocol.core.methods.response.EthGetBalance;
import org.web3j.protocol.core.methods.response.EthGetTransactionCount;
import org.web3j.protocol.core.methods.request.Transaction;
import org.web3j.protocol.core.methods.response.EthSendTransaction;
import org.web3j.protocol.http.HttpService;
import org.web3j.protocol.core.DefaultBlockParameterName;
import java.math.BigInteger;




/**
 * Created by Guillaume on 28/05/2018.
 */

public class AccessBlockchain {
    private static final String node2 = "http://93.30.148.59:1402";
    private static final String node1 = "http://93.30.148.59:1401";
    //private static String address_test = "0x5421c79d465a288c28e10aa43f9b7dff1b313c8e";
    //Web3j web3jNode2 = Web3jFactory.build(new HttpService(node2));

    public static void main(String [ ] args)
    {
        try{
            //USED FOR TEST

            /*
            Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
            System.out.println(web3jNode1.ethCoinbase().sendAsync().get().getResult());

            EthGetTransactionCount transactionCount = web3jNode1.ethGetTransactionCount(address_test, DefaultBlockParameterName.LATEST).sendAsync().get();
            System.out.println(transactionCount);
            BigInteger nonce = transactionCount.getTransactionCount();
            System.out.println(nonce);
            */

            //BigInteger test = getTheBalanceOfWallet(address);
            //System.out.println(test);

            //Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
            //Web3j web3jNode2 = Web3jFactory.build(new HttpService(node2));
            //System.out.println("ethAccounts : "+web3jNode1.ethAccounts().send().getAccounts());
            //System.out.println("ethGasPrice : "+web3jNode1.ethGasPrice().send().getGasPrice());
            //System.out.println("ethGetWork : "+web3jNode1.ethGetWork().send().getResult());
            //System.out.println("ethBlockNumber : "+web3jNode1.ethBlockNumber().send().getResult());
            //EthGetBalance ethGetBalance = web3jNode1.ethGetBalance("0x5421c79d465a288c28e10aa43f9b7dff1b313c8e", DefaultBlockParameterName.LATEST).sendAsync().get();
           // BigInteger wei = ethGetBalance.getBalance();
            //System.out.println("wei is : "+wei);

            //System.out.println("*************************************************");
            //Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
            //Web3j web3jNode2 = Web3jFactory.build(new HttpService(node2));
            //System.out.println("ethAccounts : "+web3jNode1.ethAccounts().send().getAccounts());
            //System.out.println("ethAccounts : "+web3jNode2.ethAccounts().send().getAccounts());
            //System.out.println("ethGasPrice : "+web3jNode2.ethGasPrice().send().getGasPrice());
            //System.out.println("ethGetWork : "+web3jNode2.ethGetWork().send().getResult());
            //System.out.println("ethBlockNumber : "+web3jNode2.ethBlockNumber().send().getResult());
            //EthGetBalance ethGetBalance2 = web3jNode2.ethGetBalance("0x0278467c617c13604b3d88b95c2257a3a8a7bc01", DefaultBlockParameterName.LATEST).sendAsync().get();
            //BigInteger wei2 = ethGetBalance2.getBalance();
            //System.out.println("wei is : "+wei2);
        }catch (Exception e){
            e.printStackTrace();
        }

    }


    //Get Balance function
    public BigInteger getTheBalanceOfWallet(String walletAddress){
        Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
        try{
            EthGetBalance ethGetBalance = web3jNode1.ethGetBalance(walletAddress, DefaultBlockParameterName.LATEST).sendAsync().get();
            BigInteger wei = ethGetBalance.getBalance();
            return wei;
        }catch (Exception e){
            e.getMessage();
            e.printStackTrace();
        }
        return null;
    }

    //Send transaction demo function
    public boolean sendTransationTo(String addressSource, String addressDestination, BigInteger amountToSend){
        Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
        try{
            EthGetTransactionCount transactionCount = web3jNode1.ethGetTransactionCount(addressSource, DefaultBlockParameterName.LATEST).sendAsync().get();
            String coinbase = web3jNode1.ethCoinbase().sendAsync().get().getResult();
            BigInteger nonce = transactionCount.getTransactionCount();
            BigInteger gasPrice = web3jNode1.ethGasPrice().send().getGasPrice();
            BigInteger gasLimit = gasPrice.multiply(BigInteger.valueOf(2));

            Transaction transaction = Transaction.createEtherTransaction(coinbase, nonce, gasPrice, gasLimit, addressDestination, amountToSend);

            EthSendTransaction ethSendTransaction = web3jNode1.ethSendTransaction(transaction).sendAsync().get();

            String txHash = ethSendTransaction.getTransactionHash();
        }catch (Exception e){
            e.getMessage();
            e.printStackTrace();
        }
        return false;
    }
}
