package com.example.monnthic.monnthicmobile;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

public class HomepageActivity extends AppCompatActivity {
    //TODO MOVE TO LOGIN ACTIVITY
    private static final String[] DUMMY_CREDENTIALS = new String[]{
            "dummy:test"
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_homepage);
        Button bRegister = findViewById(R.id.register);
        Button bLogin = findViewById(R.id.login);
        Button bDemo = findViewById(R.id.demo);

        bRegister.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                launchRegisterActivity();
            }
        });
        bLogin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                launchLoginActivity();
            }
        });
        bDemo.setOnClickListener(new View.OnClickListener(){
            public void onClick(View view){
                launchDemoActivity();
            }
        });
    }

    public void launchRegisterActivity(){
        Intent registerIntent = new Intent(HomepageActivity.this, SignupActivity.class);
        HomepageActivity.this.startActivity(registerIntent);
    }
    public void launchLoginActivity(){
        Intent loginIntent = new Intent(HomepageActivity.this, LoginActivity.class);
        HomepageActivity.this.startActivity(loginIntent);
    }
    public void launchDemoActivity(){
        Intent demoIntent = new Intent(HomepageActivity.this, DemoActivity.class);
        HomepageActivity.this.startActivity(demoIntent);
    }
}
