package com.example.monnthic.monnthicmobile;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class LoginActivity extends AppCompatActivity {

    private EditText email;
    private EditText password;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        email = findViewById(R.id.editTextEmail);
        password = findViewById(R.id.editTextPassword);
        Button buttonCancel = findViewById(R.id.buttonCancel);
        Button buttonOk = findViewById(R.id.buttonOk);

        buttonCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
        buttonOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                validateInput();
            }
        });
    }

    public void onClickForgetPassword(View v){
        Toast.makeText(this, "Forget password", Toast.LENGTH_SHORT).show();
    }
    public void onClickForgetEmail(View v){
        Toast.makeText(this, "Forget email", Toast.LENGTH_SHORT).show();
    }
    public void validateInput(){
        if(isEmptyEdit(email)){
            Toast.makeText(this, "You did not enter your email", Toast.LENGTH_SHORT).show();
        } else if(isEmptyEdit(password)) {
            Toast.makeText(this, "You did not enter your password", Toast.LENGTH_SHORT).show();
        } else {
            if(checkUser(email.getText().toString(),password.getText().toString())){
                launchWalletActivity(1);
            }else{
                Toast.makeText(this, "Wrong authentification", Toast.LENGTH_SHORT).show();
            }
        }
    }
    private boolean isEmptyEdit(EditText etText) {
        return etText.getText().toString().trim().length() == 0;
    }
    //TODO CHECK USER AND SEND BACK ID
    private boolean checkUser(String m, String p){
        return true;
    }
    public void launchWalletActivity(int ldapId){;
        //LAUNCH APP WALLET WITH ID USER
        Intent walletIntent = new Intent(LoginActivity.this, WalletActivity.class);
        walletIntent.putExtra("idUser", ldapId);
        LoginActivity.this.startActivity(walletIntent);
        finish();
    }
}
